Macro TNP Solution

From FreeCAD Documentation
Revision as of 09:35, 10 September 2022 by David69 (talk | contribs) (Created page with "À la fin, j'assigne la nouvelle face à l'esquisse et je recalcule. Pour être honnête, la partie la plus difficile a été d'assigner la face à Sketch.Support, pour moi la...")
Other languages:

Macro TNP solution

Description
Il s'agit d'une solution pour le problème de dénomination topologique

Version macro : 1.0
Date dernière modification : 2022-08-16
Auteur
[[User:{{{Author}}}|{{{Author}}}]]
Téléchargement
None
Liens
Version Macro
1.0
Dernière modification
2022-08-16
Version(s) FreeCAD
None
Raccourci clavier
None
Voir aussi
None

Description

Il s'agit d'une solution pour le problème de dénomination décrit à la page : Problème de dénomination topologique.

Si vous construisez un objet sur un autre objet, ainsi qu'une esquisse, il est simple à résoudre, car vous savez deux choses :

  1. Les points de l'esquisse font toujours partie de la face inférieure.
  2. L'esquisse et la face inférieure sont dans le même plan.

Pour résoudre le problème du problème de dénomination topologique, vous pouvez :

Sauvegardez la clé avant toute opération :

Il suffit de sauvegarder la clé avant toute opération. Dans l'exemple décrit à la page Problème de dénomination topologique, l'objet se trouve dans le plan XY. J'utilise donc la valeur de l'axe Z du centre de Sketch BoundBox :

ad = FreeCAD.ActiveDocument
p2 = ad.Pad002
s2 = p2.Profile[0]
key = round(s2.Shape.BoundBox.Center[2], precision)

Ensuite, recherchez la clé stockée sur toutes les faces :

Après le redimensionnement, je recherche la clé stockée sur toutes les faces. Parce que si l'esquisse et la face étaient sur le même plan XY, la valeur de l'axe Z était la même pour les deux. Dans l'atelier PartDesign, vous ne pouvez pas déplacer le troisième bloc au-dessus du deuxième bloc, pour avoir un espace entre les deux, c'est un objet unique, le bloc suivant avec l'esquisse touchera toujours la face. Sur la nouvelle face, la valeur de l'axe Z sera toujours la même que la clé stockée. Donc, il faut retourner l'index de la face. Il n'y a rien de plus à faire.

def getFaceIndex(iObj, iBB):
	
	index = 0	

	for f in iObj.Shape.Faces:

		index += 1
		bb = round(f.BoundBox.Center[2], precision)
		if bb == iBB:
			return index

	return -1

Dernières étapes

À la fin, j'assigne la nouvelle face à l'esquisse et je recalcule. Pour être honnête, la partie la plus difficile a été d'assigner la face à Sketch.Support, pour moi la syntaxe est époustouflante ;-)

Code for the example

File for testing has been uploaded at FreeCAD forum: TNP.FCStd.

__Title__="TNP_solution"
__Author__ = "Dprojects"
__Version__ = "1.0"
__Date__    = "2022-08-16"
__Comment__ = ""
__Web__ = "https://github.com/dprojects/Woodworking"
__Wiki__ = "https://wiki.freecadweb.org/TNP_solution"
__Icon__  = "TNP_solution.png"
__IconW__  = "TNP_solution.png"
__Help__ = "solution for Topological Naming Problem"
__Status__ = "stable"
__Requires__ = ""
__Communication__ = "http://www.freecadweb.org/wiki/index.php?title=User:Dprojects"

# ####################################################################
#
# This is solution for Topological Naming Problem described at 
# https://wiki.freecadweb.org/Topological_naming_problem
#
# MIT License
# 
# Copyright (c) 2022 Darek L github.com/dprojects
# 
# Permission is hereby granted, free of charge, to any 
# person obtaining a copy of this software and associated 
# documentation files (the "Software"), to deal in the 
# Software without restriction, including without limitation 
# the rights to use, copy, modify, merge, publish, distribute, 
# sublicense, and/or sell copies of the Software, and to permit 
# persons to whom the Software is furnished to do so, subject 
# to the following conditions:
# 
# The above copyright notice and this permission notice shall 
# be included in all copies or substantial portions of the Software.
# 
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, 
# EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES 
# OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND 
# NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT 
# HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, 
# WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, 
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
# DEALINGS IN THE SOFTWARE.
# 
# ####################################################################

import FreeCAD

# this should be set according 
# FreeCAD user GUI precision settings
precision = 5

# global settings
ad = FreeCAD.ActiveDocument

# middle object to be resized
p1 = ad.Pad001
s1 = p1.Profile[0]

# top object bottom to store key
p2 = ad.Pad002
s2 = p2.Profile[0]

# ####################################################################
def getFaceIndex(iObj, iBB):
	
	index = 0	

	for f in iObj.Shape.Faces:

		index += 1
		bb = round(f.BoundBox.Center[2], precision)
		
		FreeCAD.Console.PrintMessage("\n")
		FreeCAD.Console.PrintMessage(index)
		FreeCAD.Console.PrintMessage(" ")
		FreeCAD.Console.PrintMessage(bb)

		if bb == iBB:
			FreeCAD.Console.PrintMessage(" <=== found")
			return index

	return -1

# ####################################################################
def makeTNP():

	# set key
	key = round(s2.Shape.BoundBox.Center[2], precision)

	# resize and cause TNP
	s1.setDatum(9, FreeCAD.Units.Quantity('350'))

	# recompute
	s1.recompute()
	p1.recompute()
	ad.recompute()

	FreeCAD.Console.PrintMessage("\n\n")
	FreeCAD.Console.PrintMessage("Stored key:"+str(key))
	FreeCAD.Console.PrintMessage("\n")

	# search all faces for solution
	solutionIndex = getFaceIndex(p1, key)
	solution = "Face"+str(solutionIndex)
	
	FreeCAD.Console.PrintMessage("\n\n")
	FreeCAD.Console.PrintMessage("Solution: "+solution)
	
	# set exact face to Sketch
	s2.Support = (p1, (solution,))
	ad.recompute()

# ####################################################################
def moveBack():

	s1.setDatum(9, FreeCAD.Units.Quantity('250'))
	s2.Support = (p1, ('Face13',))
	ad.recompute()

# ####################################################################
# main
# ####################################################################

# uncomment what you want
makeTNP()
#moveBack()

# ####################################################################

THE Solution

This code above shows how to solve the example from Topological Naming Problem described at: Topological Naming Problem but exactly the same rules you can use to solve other problems. The approach is simple:

  1. Store the key before any operation
  2. Search for the key after operation

The specific implementation may be different. In this example the plane is XY, but you can do exactly the same for other axes. Also you can choose other key. At Woodworking project I make many operations at non-existing objects, so I had to solve the Topological Naming Problem many times.

Here I change Cube objects into PartDesign Thickness objects:

On the example below, I change Cubes into PartDesign Chamfers, so I had to store key for edges:

This example below is little more complicated because as you see at the GUI screen, the references to the object and face changes automatically. But also to make a hole I call function defined in my library not directly in the tool. So, I had to use small trick with selection and deselection, to get new reference:

There are many such problems when programming in FreeCAD, but they can all be solved in a similar way. I hope, it helps.